#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>

#include <sys/types.h>
#include <sys/stat.h>

#include <fcntl.h>

#include <readline/readline.h>

#include "netops.h"
#include "filetree.h"
#include "commands.h"
#include "systool.h"


int main(int argc, char *argv[])
{
    int sock;
    int log;
    struct linelist *buff, *temp;


    if((sock = servattach("scrub.osd.bsdi.com", 31337, "BSDI", "")) < 0)
    {
	printf("error connecting to server\n");
	return(-1);
    }

    if((log = open("/tmp/systool.log", O_CREAT | O_RDWR)) == NULL)
    {
        printf("error creating log file\n");
        return(-1);
    }

    sendmessage(sock, "LISTPROFILES\n");
    buff = recvmessage(sock);
/*    runmenu(buff);*/
    freelines(buff);

    /* use CMD defines soon as we do this the real way */
    sendmessage(sock, "GETPROFILE 4.2-STANDARD\n");
    buff = recvmessage(sock);
    installtree(sock, "4.2-STANDARD", NULL, buff, log, 0);
    freelines(buff);

    sendmessage(sock, "HELP\n");
    buff = recvmessage(sock);
    temp = buff;
    while(temp->next != NULL)
    {
	printf("help: %s\n", temp->line);
	temp = temp->next;
    }
    freelines(buff);

    sendmessage(sock, "QUIT\n");

    close(sock);

    return(0);
}


/* runmenu()
 *
 * Simple menu interface that is dependant upon readline.
 */
char runmenu(struct linelist *items)
{
    int x;
    char ret;


    /* print out the menu items */
    x = 1;
    while(items->next != NULL)
    {
	printf("%d) %s", x++, items->line);
	items = items->next;
    }

    /* ask for an option until a valid one is recieved */
    do {
	ret = atoi(readline("choice: "));
    } while(ret < 1 || ret > x-1);

    /* return the number of the chosen option */
    return(ret);
}


/* does this stuff really belong in this file? move it if systool.c gets big */
char *getline(struct linelist *lines, int number)
{
    if(number-- < 1)
	return(NULL);

    while(number--)
	if(lines->next == NULL)
	    return(NULL);
	else
	    lines = lines->next;

    return(lines->line);
}
	

void freelines(struct linelist *lines)
{
    struct linelist *curr;


    while(lines->next != NULL)
    {
	curr = lines;
	lines = lines->next;
	free(curr->line);
	free(curr);
    }
}
