#!/usr/local/bin/bltwish
# Copyright (c) 2000 Murray Stokely, BSDi
# All rights reserved.
#
# Redistribution and use in source and binary forms, with or without
# modification, are permitted provided that the following conditions
# are met:
# 1. Redistributions of source code must retain the above copyright
#    notice, this list of conditions and the following disclaimer
#    in this position and unchanged.
# 2. Redistributions in binary form must reproduce the above copyright
#    notice, this list of conditions and the following disclaimer in the
#    documentation and/or other materials provided with the distribution.
# 3. The name of the author may not be used to endorse or promote products
#    derived from this software withough specific prior written permission
#
# THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS OR
# IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
# OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
# IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT,
# INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT
# NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
# DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
# THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
# (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF
# THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
#
# GUI Interface to the binary update client library.
#

package require BLT
load ./tclbind.so updates
package require updates
namespace import blt::*

set serverName "scrub.osd.bsdi.com"
set portNum 31337
set loginName "BSDI"
set password ""

## Displays the banner at the top of the GUI screen

proc top_banner {} {
    frame .top -background white
    frame .top.right -background white
    label .top.image -background white -image \
	    [image create photo -file bsdi.gif]
    label .top.right.label -background white -text \
	    "FreeBSD Network Update Tool"
    pack .top.image -side left
    pack .top.right -side right
    pack .top.right.label
    pack .top -side top
}

proc contact_server {serverName portNum} {
    puts stdout "$serverName $portNum"
}

## Create the form layout for thxe configuration tab

proc create_configuration_tabset {} {
    global serverName
    global portNum
    global loginName
    global password

    frame .bottom.ts.form -background white -width 320 -height 400 \
	    -height 600 -width 500
    table .bottom.ts.form
    label .bottom.ts.form.server -background white -text "Server : "
    table .bottom.ts.form .bottom.ts.form.server 0,0
    entry .bottom.ts.form.entry -background white -textvariable serverName
    table .bottom.ts.form .bottom.ts.form.entry 0,1
    label .bottom.ts.form.port -background white -text "Port : "
    table .bottom.ts.form .bottom.ts.form.port 0,2
    entry .bottom.ts.form.portentry -background white -textvariable portNum
    table .bottom.ts.form .bottom.ts.form.portentry 0,3

    label .bottom.ts.form.user -background white -text "Username : "
    table .bottom.ts.form .bottom.ts.form.user 1,0
    entry .bottom.ts.form.userentry -background white -textvariable loginName
    table .bottom.ts.form .bottom.ts.form.userentry 1,1

    label .bottom.ts.form.password -background white -text "Password : "
    table .bottom.ts.form .bottom.ts.form.password 1,2
    entry .bottom.ts.form.pwentry -background white -textvariable password
    table .bottom.ts.form .bottom.ts.form.pwentry 1,3


    label .bottom.ts.form.localdir -background white -text "Local directory : "
    table .bottom.ts.form .bottom.ts.form.localdir 2,0
    entry .bottom.ts.form.direntry -background white -textvariable localDir
    table .bottom.ts.form .bottom.ts.form.direntry 2,1
    button .bottom.ts.form.connect -background white -text "Connect" -command {
	contact_server $serverName $portNum
    }
    table .bottom.ts.form .bottom.ts.form.connect 3,0
    .bottom.ts tab configure "Configuration" -window ".bottom.ts.form" -anchor n
}

proc create_playground_tabset {} {
    #.tb -background white -width 320
    hierbox .bottom.ts.h -yscrollcommand { .vs set } \
	    -xscrollcommand { .hs set } \
	    -tile [image create photo -file bg.gif] -width 350
    scrollbar .vs -orient vertical -command { .bottom.ts.h yview }
    scrollbar .hs -orient horizontal -command { .bottom.ts.h xview }

    ## Add entries to the hierbox.
    .bottom.ts.h insert end bin
    .bottom.ts.h insert end catpages
    .bottom.ts tab configure "Playground" -window ".bottom.ts.h"
}

proc create_tabset {} {
    tabset .bottom.ts -relief sunken -borderwidth 1 -width 350 \
	    -background black -highlightcolor blue
    .bottom.ts insert end "Configuration"
    .bottom.ts insert end "Playground"
    create_configuration_tabset
    create_playground_tabset
    pack .bottom.ts
}

puts stdout [open_connection $serverName $portNum $loginName $password]
top_banner
frame .bottom -background white
create_tabset
pack .bottom

