/*-
 * Copyright (c) 2000 Murray Stokely, BSDi
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer
 *    in this position and unchanged.
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 * 3. The name of the author may not be used to endorse or promote products
 *    derived from this software withough specific prior written permission
 *
 * THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS OR
 * IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
 * OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
 * IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT,
 * INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT
 * NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
 * DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
 * THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
 * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF
 * THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 *
 */

#include <string.h>

#include "updated.h"
#include "wrappers.h"
#include "commands.h"

void
displayHelp(int fd) {
    WriteX(fd,"Command Help\n"
	   "------------\n"
	   "LOGIN <loginname>\\n\n"
	   "LISTPROFILES\\n\n"
	   "GETPROFILE <profilename>\\n\n"
	   "GETDIST <profilename> <distname>\\n\n"
	   "GETFILE <profilename> <distname> <filename>\\n\n"
	   "For help on a specific command, enter : \n"
	   "HELP <command>\\n\n");
}

void
specificHelp(int fd, char *cmd)
{
    if (strstr(cmd, CMD_LISTPROF)) {
	WriteX(fd,CMD_LISTPROF " : \n"
	       "This command lists the names of all known profiles\n");
    } else if (strstr(cmd, CMD_GETPROF)) {
	WriteX(fd,CMD_GETPROF " <profilename> : \n"
	       "This command returns the contents of a profile.\n"
	       "Each entity in the profile is returned one line at a time in this format : \n"
	       "X <entityname> <options>\\n\n"
	       "Where X is is either 'F' for file, or 'A' for action.\n");
    } else if (strstr(cmd, CMD_GETDIST)) {
	WriteX(fd,CMD_GETDIST " <profilename> <distname>: \n"
	       "This command returns the contents of a distribution.\n"
	       "Each entity in the distribution is returned one line at a time in this format : \n"
	       "X <entityname> <options>\\n\n"
	       "Where X is is either 'F' for file, or 'A' for action.\n");
    } else if (strstr(cmd, CMD_GETFILE)) {
	WriteX(fd,CMD_GETFILE " <profilename> <distname> <filename>\n"
	       "This command returns a binary stream of the contents of the requested file.\n");
    } else 
	displayHelp(fd);
}
